﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Plan
{
    internal class OporniyPlan
    {
        int[,] Otvet;
        bool m;
        int[,] Tarif;
        int[] ai;
        int[] bj;

        public void Vvod()
        {
            Console.WriteLine("Введите количество поставщиков:");
            int a = Convert.ToInt32(Console.ReadLine());
            ai = new int[a];
            for (int i = 0; i < ai.Length; i++)
            {
                Console.WriteLine($"Введите предложения на {i + 1} складе:");
                ai[i] = Convert.ToInt32(Console.ReadLine());
            }
            Console.WriteLine("Введите количество потребителей:");
            int b = Convert.ToInt32(Console.ReadLine());
            bj = new int[b];
            for (int i = 0; i < bj.Length; i++)
            {
                Console.WriteLine($"Введите спрос на {i + 1} пункте:");
                bj[i] = Convert.ToInt32(Console.ReadLine());
            }
            int Suma = ai.Sum();
            int Sumb = bj.Sum();
            if (Suma == Sumb)
            {
                m = true;
            }
            else { m = false; }
            Tarif = new int[a, b];
            for (int i = 0; i < Tarif.GetLength(0); i++)
            {
                for (int j = 0; j < Tarif.GetLength(1); j++)
                {
                    Console.WriteLine($"Введите тариф с {i + 1} склада на {j + 1} пункт");
                    Tarif[i, j] = Convert.ToInt32(Console.ReadLine());
                }
            }
        }
        public void NorthWest()
        {
            Otvet = new int[ai.Length, bj.Length];

            for (int j = 0; j < Otvet.GetLength(1); j++)
            {
                for (int i = 0; i < Otvet.GetLength(0); i++)
                {
                    if (ai[i] > bj[j])
                    {
                        Otvet[i, j] = bj[j];
                        ai[i] = ai[i] - bj[j];
                        bj[j] = bj[j] - bj[j];
                    }
                    else
                    {
                        Otvet[i, j] = ai[i];
                        bj[j] = bj[j] - ai[i];
                        ai[i] = ai[i] - ai[i];
                    }
                }
            }


        }
        private void MinElemArray(int[,] Tarif, out int indexi, out int indexj)
        {
            indexi = 0;
            indexj = 0;
            int min = 100;
            for (int i = 0; i < Tarif.GetLength(0); i++)
            {
                for (int j = 0; j < Tarif.GetLength(1); j++)
                {
                    if (min > Tarif[i, j])
                    {
                        min = Tarif[i, j];
                        indexi = i;
                        indexj = j;
                    }
                }
            }
        }
        private void MinElemArrayPlus(int[,] Tarif, int[,] Plus, out int indexi, out int indexj)
        {
            indexi = 0;
            indexj = 0;
            int min = 100;
            for (int i = 0; i < Tarif.GetLength(0); i++)
            {
                for (int j = 0; j < Tarif.GetLength(1); j++)
                {
                    if (min > Tarif[i, j] && Plus[i, j] != 0)
                    {
                        min = Tarif[i, j];
                        indexi = i;
                        indexj = j;
                    }
                }
            }
        }
        public void MinElem()
        {
            int i;
            int j;
            int[,] CloneTarif = (int[,])Tarif.Clone();
            Otvet = new int[ai.Length, bj.Length];
            while (ai.Sum() != 0 && bj.Sum() != 0)
            {
                MinElemArray(CloneTarif, out i, out j);
                if (ai[i] > bj[j])
                {
                    Otvet[i, j] = bj[j];
                    ai[i] = ai[i] - bj[j];
                    bj[j] = bj[j] - bj[j];
                }
                else
                {
                    Otvet[i, j] = ai[i];
                    bj[j] = bj[j] - ai[i];
                    ai[i] = ai[i] - ai[i];
                }
                CloneTarif[i, j] = 100;

            }
        }
        private int MinElemRow(int[,] Tarif, int i)
        {
            int min = 100;
            for (int j = 0; j < Tarif.GetLength(1); j++)
            {
                if (min > Tarif[i, j])
                {
                    min = Tarif[i, j];
                }
            }
            return min;
        }
        private int MinElemColumn(int[,] Tarif, int j)
        {
            int min = 100;
            for (int i = 0; i < Tarif.GetLength(0); i++)
            {
                if (min > Tarif[i, j])
                {
                    min = Tarif[i, j];
                }
            }
            return min;
        }
        private int Sum(int[,] Plus)
        {
            int sum = 0;
            for (int i = 0; i < Plus.GetLength(0); i++)
                for (int j = 0; j < Plus.GetLength(1); j++)
                    sum += Plus[i, j];
            return sum;
        }
        public void DoubleLike()
        {
            int i;
            int j;
            int[,] Plus = new int[ai.Length, bj.Length];
            int[,] CloneTarif = (int[,])Tarif.Clone();
            Otvet = new int[ai.Length, bj.Length];
            for (i = 0; i < Plus.GetLength(0); i++)
            {
                for (j = 0; j < Plus.GetLength(1); j++)
                {
                    if (Tarif[i, j] == MinElemRow(Tarif, i))
                    {
                        Plus[i, j]++;
                    }
                    if (Tarif[i, j] == MinElemColumn(Tarif, j))
                    {
                        Plus[i, j]++;
                    }
                }
            }
            while (Sum(Plus) != 0)
            {
                MinElemArrayPlus(CloneTarif, Plus, out i, out j);
                if (ai[i] > bj[j])
                {
                    Otvet[i, j] = bj[j];
                    ai[i] = ai[i] - bj[j];
                    bj[j] = bj[j] - bj[j];
                }
                else
                {
                    Otvet[i, j] = ai[i];
                    bj[j] = bj[j] - ai[i];
                    ai[i] = ai[i] - ai[i];
                }
                CloneTarif[i, j] = 100;
                Plus[i, j] = 0;
            }
            while (ai.Sum() != 0 && bj.Sum() != 0)
            {
                MinElemArray(CloneTarif, out i, out j);
                if (ai[i] > bj[j])
                {
                    Otvet[i, j] = bj[j];
                    ai[i] = ai[i] - bj[j];
                    bj[j] = bj[j] - bj[j];
                }
                else
                {
                    Otvet[i, j] = ai[i];
                    bj[j] = bj[j] - ai[i];
                    ai[i] = ai[i] - ai[i];
                }
                CloneTarif[i, j] = 100;

            }

        }
        private int MinElemRowFogel(int[,] Tarif, int i, int[,] Otvet)
        {
            int min = 100;
            int index = 0;
            for (int j = 0; j < Tarif.GetLength(1); j++)
            {
                if (Otvet[i, j] != 0)
                {
                    /*                    Console.WriteLine("Ура");*/
                }
                else if (min > Tarif[i, j])
                {
                    min = Tarif[i, j];
                    index = j;
                }
            }
            /*            Console.WriteLine("Выполнено в столбце ");*/
            return index;
        }
        private int MinElemColumnFogel(int[,] Tarif, int j, int[,] Otvet)
        {
            int index = 0;
            int min = 100;
            for (int i = 0; i < Tarif.GetLength(0); i++)
            {
                if (Otvet[i, j] != 0)
                {

                }
                else if (min > Tarif[i, j])
                {
                    min = Tarif[i, j];
                    index = i;
                }
            }
            /*            Console.WriteLine("Выполнено в строке ");*/
            return index;
        }
        private void MaxShtraf(int[,] Tarif, int[,] Otvet, out int indexMaxshtr, out bool flag)
        {
            int[] di = new int[Tarif.GetLength(0)];
            int[] dj = new int[Tarif.GetLength(1)];
            int min1;
            int min2;
            for (int i = 0; i < Tarif.GetLength(0); i++)
            {
                min1 = 100;
                min2 = 100;
                for (int j = 0; j < Tarif.GetLength(1); j++)
                {
                    if (Otvet[i, j] != 0)
                    {

                    }
                    else if (min1 > Tarif[i, j] && min1 != Tarif[i, j])
                    {
                        min2 = min1;
                        min1 = Tarif[i, j];
                    }
                    else if (min2 > Tarif[i, j] && min1 != Tarif[i, j])
                    {
                        min2 = Tarif[i, j];
                    }
                }

                if (min2 == 100 && min1 == 100)
                {
                    min2 = 0;
                    min1 = 0;
                }
                else if (min2 == 100)
                {
                    min2 = min1 * 2;
                }
                di[i] = min2 - min1;
            }
            for (int j = 0; j < Tarif.GetLength(1); j++)
            {
                min1 = 100;
                min2 = 100;
                for (int i = 0; i < Tarif.GetLength(0); i++)
                {
                    if (Otvet[i, j] != 0)
                    {
                    }
                    else if (min1 > Tarif[i, j] && min1 != Tarif[i, j])
                    {
                        min2 = min1;
                        min1 = Tarif[i, j];
                    }
                    else if (min2 > Tarif[i, j] && min1 != Tarif[i, j])
                    {
                        min2 = Tarif[i, j];
                    }
                }
                if (min2 == 100 && min1 == 100)
                {
                    min2 = 0;
                    min1 = 0;
                }
                if (min2 == 100)
                {
                    min2 = min1 * 2;
                }
                dj[j] = min2 - min1;
            }

            /* for (int i = 0; i < dj.Length; i++)
             {
                 Console.Write(dj[i] + " ");
             }
             Console.WriteLine();
             for (int i = 0; i < di.Length; i++)
             {
                 Console.Write(di[i] + " ");
             }*/
            flag = true;
            int MaxShtr;
            int MaxShtrafdi = di.Max();
            int MaxShtrafdj = dj.Max();
            int MaxShtrafindexdi = di.ToList().IndexOf(MaxShtrafdi);
            int MaxShtrafindexdj = dj.ToList().IndexOf(MaxShtrafdj);
            /* Console.Write(MaxShtrafdj + " " + MaxShtrafindexdj);
             Console.WriteLine();
             Console.Write(MaxShtrafdi + " " + MaxShtrafindexdi);
             Console.WriteLine();*/
            if (MaxShtrafdi > MaxShtrafdj)
            {
                MaxShtr = MaxShtrafdi;
                indexMaxshtr = di.ToList().IndexOf(MaxShtr);
            }
            else
            {
                MaxShtr = MaxShtrafdj;
                indexMaxshtr = dj.ToList().IndexOf(MaxShtr);
                flag = false;
            }


        }
        public void Fogel()
        {
            int i;
            int j;
            bool flag;
            int indexshtraf;
            int[,] CloneTarif = (int[,])Tarif.Clone();
            Otvet = new int[ai.Length, bj.Length];
            int h = 0;
            while (ai.Sum() != 0 && bj.Sum() != 0)
            {
                MaxShtraf(CloneTarif, Otvet, out indexshtraf, out flag);
                if (flag)
                {
                    i = indexshtraf;
                    j = MinElemRowFogel(Tarif, indexshtraf, Otvet);
                }
                else
                {
                    i = MinElemColumnFogel(Tarif, indexshtraf, Otvet);
                    j = indexshtraf;
                }
                if (ai[i] > bj[j])
                {
                    Otvet[i, j] = bj[j];
                    ai[i] = ai[i] - bj[j];
                    bj[j] = bj[j] - bj[j];
                    for (int i1 = 0; i1 < Otvet.GetLength(0); i1++)
                    {
                        if (Otvet[i1, j] == 0)
                        {
                            Otvet[i1, j] = 1000;
                        }
                    }
                }
                else
                {
                    Otvet[i, j] = ai[i];
                    bj[j] = bj[j] - ai[i];
                    ai[i] = ai[i] - ai[i];

                    for (int i1 = 0; i1 < Otvet.GetLength(1); i1++)
                    {
                        if (Otvet[i, i1] == 0)
                        {
                            Otvet[i, i1] = 1000;
                        }
                    }
                }
                h++;
            }
            for (i = 0; i < Otvet.GetLength(0); i++)
            {
                for (j = 0; j < Otvet.GetLength(1); j++)
                {
                    if (Otvet[i, j] == 1000)
                    {
                        Otvet[i, j] = 0;
                    }
                }
            }
        }
        public void vivod()
        {
            Console.WriteLine();
            Console.WriteLine("Матрица ");
            for (int i = 0; i < Otvet.GetLength(0); i++)
            {
                for (int j = 0; j < Otvet.GetLength(1); j++)
                {
                    Console.Write(Otvet[i, j] + " ");
                }
                Console.WriteLine();
            }
            Console.WriteLine();
            int L = 0;
            for (int i = 0; i < Otvet.GetLength(0); i++)
            {
                for (int j = 0; j < Otvet.GetLength(1); j++)
                {
                    L = L + Otvet[i, j] * Tarif[i, j];
                }

            }
            Console.WriteLine("Целевая функция = " + L);

            Otvet.Clear();
        }

        public void potencial()
        {
            bool flag = true;
            bool Optimal = true;
            int[] pi = new int[ai.Length];
            int[] pj = new int[bj.Length];
            int[] pic = new int[pi.Length];
            pic[0] = 1;
            int[] pjc = new int[pj.Length];
            while (flag)
            {
                for (int i = 0; i < pi.Length; i++)
                {
                    for (int j = 0; j < pj.Length; j++)
                    {
                        if (Otvet[i, j] != 0)
                        {
                            if (i == 0)
                            {
                                pj[j] = Tarif[i, j];
                                pjc[j] = 1;
                            }
                            else
                            {
                                if (pi[i] != 0)
                                {
                                    pj[j] = Tarif[i, j] - pi[i];
                                    pjc[j] = 1;
                                }
                                else if (pj[j] != 0)
                                {
                                    pi[i] = Tarif[i, j] - pj[j];
                                    pic[i] = 1;
                                }
                                else
                                {

                                }
                            }

                        }
                    }
                }
                flag = false;
                foreach (int i in pic)
                {
                    if (i == 0)
                    {
                        flag = true;
                    }
                }
                foreach (int i in pjc)
                {
                    if (i == 0)
                    {
                        flag = true;
                    }
                }
            }

            for (int i = 0; i < pi.Length; i++)
            {
                Console.Write(pi[i] + " ");
            }
            Console.WriteLine();
            for (int i = 0; i < pj.Length; i++)
            {
                Console.Write(pj[i] + " ");
            }
            Console.WriteLine();
            int[,] Potencial = new int[pi.Length, pj.Length];

            for (int i = 0; i < Potencial.GetLength(0); i++)
            {
                for (int j = 0; j < Potencial.GetLength(1); j++)
                {
                    if (Otvet[i, j] == 0)
                    {
                        Potencial[i, j] = (pi[i] + pj[j]) - Tarif[i, j];
                        if (Potencial[i, j] > 0)
                        {
                            Optimal = false;
                        }
                    }
                }
            }

            for (int i = 0; i < Potencial.GetLength(0); i++)
            {
                for (int j = 0; j < Potencial.GetLength(1); j++)
                {
                    Console.Write(Potencial[i, j] + " ");
                }
                Console.WriteLine();
            }

            if (Optimal)
            {
                Console.WriteLine("Опорный план оптимальный");
            }
            else
            {
                Console.WriteLine("Опорный план не оптимальный");
                Console.WriteLine("Вы хотите ввести новую матрицу");
                string v = Console.ReadLine();
                if (v == "да")
                {
                    for (int i = 0; i < Otvet.GetLength(0); i++)
                    {
                        for (int j = 0; j < Otvet.GetLength(1); j++)
                        {
                            Console.WriteLine($"Введите поставку с {i + 1} склада на {j + 1} пункт");
                            Otvet[i, j] = Convert.ToInt32(Console.ReadLine());
                        }
                    }
                    potencial();
                }
            }

        }
        public void Main()
        {
            Vvod();
            if (m)
            {
                Console.WriteLine("1. Северо-западный");
                Console.WriteLine("2. Минимального элемента");
                Console.WriteLine("3. Двойного предпочтения");
                Console.WriteLine("4. Апроксимации фогеля");
                Console.WriteLine("Введите номер задания");
                int v = Convert.ToInt32(Console.ReadLine());
                switch (v)
                {
                    case 1:
                        NorthWest();
                        vivod();
                        potencial();
                        break;

                    case 2:
                        MinElem();
                        vivod();
                        potencial();
                        break;
                    case 3:
                        DoubleLike();
                        vivod();
                        potencial();
                        break;
                    case 4:
                        Fogel();
                        vivod();
                        potencial();
                        break;
                    default:
                        break;
                }


            }
            else
            {
                Console.WriteLine("Я пока не умею");
            }

        }
    }
}
